program demo;

{$mode delphi}

uses sysutils, pqconnection, sqldb, contact, fpjson, rttitojson.types, objtodb.types, rest.types, rttitojson.writer, objtodb.reader;

Procedure WriteJSON(P :  TPerson);

var
  Writer : TRTTIJSONWriter;
  JSON : TJSONObject;
begin
  JSON:=Nil;
  Writer:=TRTTIJSONWriter.Create;
  try
    JSON:=Writer.ToJSON<TPerson>(P);
    Writeln('JSON : ',JSON.FormatJSON());
  finally
    JSON.Free;
    Writer.Free;
  end;
end;

Function NewPerson : TPerson;

begin
  Result.id:=1;
  Result.FirstName:='Kirth';
  Result.LastName:='Gersen';
  Result.birthdate:=EncodeDate(1486,5,14);
end;

Function GetConnection : TSQLConnection;
begin
  Result:=TPQConnection.Create(Nil);
  Result.DatabaseName:='fpctest';
  Result.UserName:='fpc';
  Result.Password:='Shimrod';
  Result.HostName:='localhost';
  Result.Transaction:=TSQLTransaction.Create(Result);
  Result.Connected:=True;
end;

Function LoadPerson(aID : Integer) : TPerson;

var
  Reader : TRTTIDBReader;
  Conn : TSQLConnection;
  P : TPerson;
  ReadOK : Boolean;

begin
  P.ID:=aID;
  conn:=GetConnection;
  try
    Reader:=TRTTIDBReader.Create(Conn);
    ReadOK:=Reader.ReadFromDB<TPerson>(P);
    if not ReadOK then
      Writeln('Failed to read person');
    Result:=P;
  finally
    Conn.Free;
  end;
end;

begin
  WriteJSON(NewPerson);
//  WriteJSON(LoadPerson(1));
end.

